> For the complete documentation index, see [llms.txt](https://docs.kubemq.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kubemq.io/configuration/cluster/set-routing.md).

# Set Routing

{% tabs %}
{% tab title="Kubemqctl" %}

## Flags

| Flag                  | Type/Options | Default | Description                           |
| --------------------- | ------------ | ------- | ------------------------------------- |
| --routing-data        | string       | ""      | Set routing data                      |
| --routing-file        | string       | ""      | set routing  file                     |
| --routing-url         | string url   | ""      | Set routing data loading url          |
| --routing-auto-reload | int          | 0       | Set auto reload routing data from url |

## Example

Set predefined routing rules data where routing.json is json array of routing rules:

```bash
kubemqctl create cluster --routing-file ./routing.json
```

{% endtab %}

{% tab title="Helm" %}

## Values

| Value              | Type/Options | Default | Description                           |
| ------------------ | ------------ | ------- | ------------------------------------- |
| routing.data       | string       | ""      | Set routing data                      |
| routing.url        | string url   | ""      | Set routing data loading url          |
| routing.autoReload | int          | 0       | Set auto reload routing data from url |

## Example

Set predefined routing rules data where routing.json is json array of routing rules:

```bash
helm install kubemq-cluster --set-file routing.data=./routing.json kubemq-charts/kubemq
```

{% endtab %}

{% tab title="kubectl" %}

## Fields

| Field      | Type/Options | Default | Description                           |
| ---------- | ------------ | ------- | ------------------------------------- |
| data       | string       | ""      | Set routing data                      |
| url        | string url   | ""      | Set routing data loading url          |
| autoReload | int          | 0       | Set auto reload routing data from url |

## Example

Set predefined routing rules data where routing.json is json array of routing rules:

Run:

```bash
kubectl apply -f {below-yaml-file}
```

```yaml
apiVersion: core.k8s.kubemq.io/v1alpha1
kind: KubemqCluster
metadata:
  name: kubemq-cluster
  namesapce: kubemq
  labels:
    app: kubemq-cluster
spec:
  replicas: 3
  authorization:
    data: |-
      [
         {
            "Key":"all-to-foo-bar",
            "Routes": "events:foo.bar;events_store:foo.bar;queues:foo.bar"
         },
         {
            "Key":"sink-to-events-channel",
            "Routes": "events:sink"
         }
      ]
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kubemq.io/configuration/cluster/set-routing.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
